/**
 *  Java GUI Tutorial 
 *  CheckboxExample.java
 *
 *  @autor Gabor Nemeth, HUNGARY 2007
 *    
 *  Licence: free for non-commercial use
 *
 *  This is a sample program without guarantee and liability.
 *  
 *
 **/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


public class CheckboxExample extends JFrame implements ItemListener {
  
  private Checkbox checkbox1;
  private Checkbox checkbox2;
  private Checkbox checkbox3;
  private Checkbox checkbox4;
  
  private JPanel textPanel;
  private JPanel checkboxPanel;
  private JPanel mainPanel;
  
  private JLabel label;
  
  public CheckboxExample() {
    super( "CheckboxExample" );
    this.setSize(350, 150);
    
    mainPanel = new JPanel();
    checkboxPanel = new JPanel();
    textPanel = new JPanel();
    checkbox1 = new Checkbox( "Audi", false );
    checkbox2 = new Checkbox( "Volkswagen", false );
    checkbox3 = new Checkbox( "Jaguar", false );
    checkbox4 = new Checkbox( "Mercedes", false );
    this.getContentPane().add(mainPanel);
    mainPanel.setLayout(new BoxLayout(mainPanel, BoxLayout.X_AXIS));
    checkboxPanel.setLayout(new BoxLayout(checkboxPanel, BoxLayout.Y_AXIS));
    checkboxPanel.add(checkbox1);
    checkboxPanel.add(checkbox2);
    checkboxPanel.add(checkbox3);
    checkboxPanel.add(checkbox4);
    mainPanel.add( checkboxPanel );
    mainPanel.add( textPanel );
    
    label = new JLabel( "Nothing selected" );
    textPanel.add( label );
    
    
    // add action listener
    checkbox1.addItemListener(this);
    checkbox2.addItemListener(this);
    checkbox3.addItemListener(this);
    checkbox4.addItemListener(this);
  }
  
  // event handling
  public void itemStateChanged(ItemEvent e) {
    // for each checkbox check its state
    // if it is checked, then we add its label to the text
    String text = "";
    boolean isFirst = true;
    if ( checkbox1.getState() == true ) {
      text = text + checkbox1.getLabel();
      isFirst = false;
    }
    if ( checkbox2.getState() == true ) {
      if ( isFirst == false ) {  // check if this car is the first in the list
        text = text + ", ";
      }
      text = text + checkbox2.getLabel();
      isFirst = false;
    }
    if ( checkbox3.getState() == true ) {
      if ( isFirst == false ) { // check if this car is the first in the list
        text = text + ", ";
      }
      text = text + checkbox3.getLabel();
      isFirst = false;
    }
    if ( checkbox4.getState() == true ) {
      if ( isFirst == false ) { // check if this car is the first in the list
        text = text + ", ";
      }
      text = text + checkbox4.getLabel();
      isFirst = false;
    }
    
    if ( text == "" ) {
      text = "Nothing selected";
    } 
    label.setText( text );
    
  }
  
  
  public static void main( String[] args ) {
    CheckboxExample frame = new CheckboxExample();
    frame.setVisible( true );
    
    
    // this is an implementation of window listener
    // the program will be stopped if you close the main frame
    WindowListener listener = new WindowAdapter() {
      public void windowClosing(WindowEvent we) {
        System.exit(0);
      }
    };
    frame.addWindowListener(listener);
    
  }
  
}